#ifndef	___Archivable_H_
#define	___Archivable_H_
//------------------------------------------------------------------------------
// BeOS
#include <Archivable.h>
#include <Entry.h>
#include <Message.h>
#include <InterfaceDefs.h>
// C++
#include <string>
//==============================================================================
class	TArchivable : public BArchivable
{
public:
	TArchivable();
	TArchivable(BMessage* oArc);
	virtual	~TArchivable();

	static BArchivable*	Instantiate(BMessage* oArc);

	virtual status_t	Archive(BMessage* oArc, bool oDeep = true) const;
	status_t			Load(const BEntry& oEntry);			// メンバ変数に情報を読込む
	status_t			Save(const BEntry& oEntry) const;	// メンバ変数から情報を保存する
	virtual status_t	Unarchive(const BMessage& oArc);	// メッセージから情報を得る

protected:
	// 以下の関数群は引数非破壊
	status_t	FindBool(const BMessage& oArc, const char* oName, bool* oValue) const;
	status_t	FindBool(const BMessage& oArc, const char* oName, int32 oIdx, bool* oValue) const;
	status_t	FindData(const BMessage& oArc, const char* oName, type_code oType, const void** oData, ssize_t* oNumBytes) const;
	status_t	FindData(const BMessage& oArc, const char* oName, type_code oType, int32 oIdx, const void** oData, ssize_t* oNumBytes) const;
	status_t	FindDouble(const BMessage& oArc, const char* oName, double* oValue) const;
	status_t	FindDouble(const BMessage& oArc, const char* oName, int32 oIdx, double* oValue) const;
	status_t	FindFloat(const BMessage& oArc, const char* oName, float* oValue) const;
	status_t	FindFloat(const BMessage& oArc, const char* oName, int32 oIdx, float* oValue) const;
	status_t	FindInt32(const BMessage& oArc, const char* oName, int32* oValue) const;
	status_t	FindInt32(const BMessage& oArc, const char* oName, int32 oIdx, int32* oValue) const;
	status_t	FindInt64(const BMessage& oArc, const char* oName, int64* oValue) const;
	status_t	FindInt64(const BMessage& oArc, const char* oName, int32 oIdx, int64* oValue) const;
	status_t	FindMessage(const BMessage& oArc, const char* oName, BMessage* oValue) const;
	status_t	FindMessage(const BMessage& oArc, const char* oName, int32 oIdx, BMessage* oValue) const;
	status_t	FindRect(const BMessage& oArc, const char* oName, BRect* oValue) const;
	status_t	FindRect(const BMessage& oArc, const char* oName, int32 oIdx, BRect* oValue) const;
	status_t	FindRef(const BMessage& oArc, const char* oName, entry_ref* oValue) const;
	status_t	FindRef(const BMessage& oArc, const char* oName, int32 oIdx, entry_ref* oValue) const;
	status_t	FindRGBColor(const BMessage& oArc, const char* oName, rgb_color* oValue) const;
	status_t	FindRGBColor(const BMessage& oArc, const char* oName, int32 oIdx, rgb_color* oValue) const;
	status_t	FindString(const BMessage& oArc, const char* oName, const char** oValue) const;
	status_t	FindString(const BMessage& oArc, const char* oName, int32 oIdx, const char** oValue) const;
	status_t	FindString(const BMessage& oArc, const char* oName, string* oValue) const;
	status_t	FindString(const BMessage& oArc, const char* oName, int32 oIdx, string* oValue) const;

private:
	typedef	BArchivable	SUPER;
};
//==============================================================================
#endif	// ___Archivable_H_
