#ifndef	___ClickableStringView_H_
#define	___ClickableStringView_H_
//------------------------------------------------------------------------------
// BeOS
#include <Control.h>
// C++
#include <string>
// Add2
#include <add2/MouseDownManager.h>
//------------------------------------------------------------------------------
//==============================================================================
class	TClickableStringView : public BControl, public TMouseDownManager
{
public:
	TClickableStringView(BRect oFrame, const char* oName, const char* oText,
			const char* oLinkToPath = "", const char* oLinkToMIME = "", BMessage* oMsg = NULL,
			uint32 oResizingMode = B_FOLLOW_NONE, uint32 oFlags = B_WILL_DRAW);
	virtual	~TClickableStringView();

	void		SetText(const char* oText);
	const char*	Text() const;

	void		SetLinkToPath(const char* oLinkToPath);
	const char*	LinkToPath() const;

	void		SetLinkToMIME(const char* oLinkToMIME);
	const char*	LinkToMIME() const;

	void		SetFocusTarget(BControl* oTgt);
	BControl*	FocusTarget() const;

	virtual void	MakeFocus(bool oFocused = true);

	virtual void	GetPreferredSize(float* oWidth, float* oHeight);

private:
	typedef	BControl	SUPER;

	virtual void	AttachedToWindow();
	virtual void	Draw(BRect oUpdateRect);
	void			DrawText();
	virtual void	MouseClickLeftSingle(BPoint oPoint);
	virtual void	MouseDown(BPoint oPoint);
	virtual void	MouseDownLeft(BPoint oPoint);
	virtual void	MouseMoved(BPoint oPoint, uint32 oTransit, const BMessage* oMsg);
	virtual void	MouseUp(BPoint oPoint);
	virtual void	MouseUpLeft(BPoint oPoint);

	string		mLinkToMIME;
	string		mLinkToPath;
	BControl*	mFocusTgt;
};
//------------------------------------------------------------------------------
//==============================================================================
#endif	// ___ClickableStringView_H_
