#ifndef	___MRUF_H_
#define	___MRUF_H_
//------------------------------------------------------------------------------
// BeOS
#include <Entry.h>
#include <Menu.h>
// C++
#include <string>
#include <deque>
// Add2
#include <add2/Archivable.h>
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
const char	MRUF_ARCNAME_MRUF[] = "MRUF";	// MRUF
//==============================================================================
/* ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
ファイル履歴管理
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
class	TMRUF : public TArchivable
{
public:
	TMRUF();
	virtual ~TMRUF();

	void				AddMRUF(const char* oPath);				// ファイルの追加
	virtual status_t	Archive(BMessage* oArc, bool oDeep = true) const;
	void				ClearMRUF();							// MRUF の削除・解放
	int32				CountMRUFs() const;						// 現在格納しているファイルの数
	BMenu*				GenerateMenu();							// 最近使ったファイルメニュー
	const char*			MRUFAt(int32 oIdx) const;				// ファイルを返す
	const char*			RemoveMRUF(int32 oIdx);					// ファイルの削除（解放はしない）
	const char*			RemoveMRUF(const char* oPath);			// 同じものを見つけて削除（解放はしない）
	void				SetAccFormat(const string& oAccFormat);	// アクセラレータキーの設定
	void				SetMaxMRUF(int32 oMaxMRUF);				// 最大格納数の設定
	void				SetMessage(BMessage* oMsg);				// メッセージの設定（所有権は移動する）
	void				SetShowSC(bool oShow);					// ショートカットの表示モード
	void				SetTgtBase(int32 oTgtBase);				// メニュー生成時の生成開始メニュー番号（0やセパレータの次を指定すると良い）
	void				SetTgtHandler(BHandler* oTgtHandler);	// メニューのターゲット
	void				SetTriggerBase(int32 oTriggerBase);		// トリガー最低値の設定
	void				SetTgtMenu(BMenu* oMenu);				// メニューをつけるべきターゲット
	virtual status_t	Unarchive(const BMessage& oArchive);	// 復元
private:
	typedef	TArchivable	SUPER;				// スーパークラス

	void	DeleteExtraMRUF();				// 余分な MRUF を削除・解放
	int32	FindMRUF(const char* oPath);	// ファイルを見付けて番号を返す
	
	bool		mShowSC;					// メニューにショートカットを表示する
	int32		mTgtBase;					// メニュー生成時にメニューのどこから生成を開始するか
	int32		mTriggerBase;				// トリガーの最低値
	int32		mMaxMRUF;					// 最大格納数
	deque<const char*>	mMRUFs;				// 最近使ったファイル（cstr）
	string		mAccFormat;					// アクセラレータキー形式
	BHandler*	mTgtHandler;				// メニューターゲット
	BMenu*		mTgtMenu;					// 最近使ったファイルを加えるメニュー
	BMessage	mMItemMsg;					// メニューアイテムが発行するメッセージ
};
//==============================================================================
#endif	// ___MRUF_H_
