/*==============================================================================
		雑多ユーティリティー関数群	for ZETA	Ver 2.52
		Copyright (C) 1999-2006 by ＳＨＩＮＴＡ
==============================================================================*/

/*==============================================================================
 Ver. |					主な改良点
--------------------------------------------------------------------------------
 ---- | 2003/11/15 (Sat) 開発着手。
 1.00 | 2003/11/16 (Sun) add 時代の関数を元に構築。
 1.10 | 2003/11/25 (Tue) merge_accelerator_key() が Windows 風のアクセラレータ形式に対応。
 1.20 | 2003/11/29 (Sat) short_cut_from_label() を作成。
 1.30 | 2003/12/07 (Sun) show_url() を作成。
 1.40 | 2003/12/07 (Sun) get_save_ref() を作成。
 1.50 | 2003/12/24 (Wed) show_alert2() を作成。
 1.60 | 2004/01/02 (Fri) adjust_value() を作成。
 1.70 | 2004/01/02 (Fri) set_text_ctrl_num() を作成。
 1.80 | 2004/09/14 (Tue) delete_mfield_mitems() を作成。
 1.90 | 2004/09/18 (Sat) close_window() を作成。
 2.00 | 2004/10/02 (Sat) get_files() を作成。
 2.10 | 2004/11/21 (Sun) locale_text_with_default() を作成。
 2.20 | 2005/10/30 (Sun) send_message_with_lock() を作成。
 2.30 | 2005/12/24 (Sat) set_str_view_num() を作成。
 2.40 | 2006/01/22 (Sun) create_icon8_from_icon24() を作成。
 2.40 | 2006/07/02 (Sun) show_alert3() を作成。
==============================================================================*/

/*=== Memo =====================================================================
==============================================================================*/

//------------------------------------------------------------------------------
#include "MiscUtils.h"
//------------------------------------------------------------------------------
// BeOS
#include <Application.h>
#include <File.h>
#include <fs_attr.h>
#include <Locale.h>
#include <MenuItem.h>
#include <Node.h>
#include <NodeInfo.h>
#include <Path.h>
#include <Roster.h>
#include <UTF8.h>
// C++
// Add2
#include "BeConstants.h"
#include "FUConstants.h"
#include "StringUtils.h"
//------------------------------------------------------------------------------
const float		MARGIN_ADJUST_CBOX_WIDTH = 2.0;			// チェックボックスサイズ最適化用
const float		MARGIN_ADJUST_MFIELD_DIVIDER = 2.0;		// メニューフィールドサイズ最適化用
const float		MARGIN_ADJUST_RBUTTON_WIDTH = 2.0;		// ラジオボタンサイズ最適化用
const float		MARGIN_ADJUST_STRVIEW_WIDTH = 2.0;		// ストリングビューサイズ最適化用
const float		MARGIN_ADJUST_TXTCTRL_DIVIDER = 2.0;	// テキストコントロールサイズ最適化用
const float		WIDTH_CBOX_BOX = 17.0;					// チェックボックスの左端からチェックの右端までの幅
const float		WIDTH_RBUTTON_BUTTON = 17.0;			// ラジオボタンの左端からチェックの右端までの幅
const bigtime_t	TIME_CLICK_BUTTON_INTERVAL = 50*1000;	// ボタンクリック時の、ボタンを押している時間
//==============================================================================
status_t	add_next_msg(BMessage* oSendMsg, const BMessage& oNextMsg, const BHandler* oNextMsgTgt)
{
	// 未デバッグ
	oSendMsg->AddMessage(MUT_MSG_NAME_NEXT_MSG, &oNextMsg);
	oSendMsg->AddPointer(MUT_MSG_NAME_NEXT_MSG_TGT, oNextMsgTgt);
	return B_OK;
}
//------------------------------------------------------------------------------
void	adjust_button_width(BButton* oButton)
{
	float	aPreferredHeight;
	float	aPreferredWidth;

	oButton->GetPreferredSize(&aPreferredWidth, &aPreferredHeight);
	oButton->ResizeTo(ceil(aPreferredWidth), oButton->Bounds().bottom);
}
//------------------------------------------------------------------------------
void	adjust_cbox_width(BCheckBox* oCBox)
{
	oCBox->ResizeTo(ceil(oCBox->StringWidth(oCBox->Label()))+WIDTH_CBOX_BOX+MARGIN_ADJUST_CBOX_WIDTH,
			oCBox->Bounds().bottom);
}
//------------------------------------------------------------------------------
void	adjust_mfield_divider(BMenuField* oMField)
{
	oMField->SetDivider(ceil(oMField->StringWidth(oMField->Label()))+MARGIN_ADJUST_MFIELD_DIVIDER);
}
//------------------------------------------------------------------------------
void	adjust_rbutton_width(BRadioButton* oRButton)
{
	oRButton->ResizeTo(ceil(oRButton->StringWidth(oRButton->Label()))+WIDTH_RBUTTON_BUTTON+MARGIN_ADJUST_RBUTTON_WIDTH,
			oRButton->Bounds().bottom);
}
//------------------------------------------------------------------------------
void	adjust_str_view_width(BStringView* oStrView)
{
	oStrView->ResizeTo(ceil(oStrView->StringWidth(oStrView->Text()))+MARGIN_ADJUST_STRVIEW_WIDTH,
			oStrView->Bounds().bottom);
}
//------------------------------------------------------------------------------
void	adjust_txt_ctrl_divider(BTextControl* oTxtCtrl)
{
	oTxtCtrl->SetDivider(ceil(oTxtCtrl->StringWidth(oTxtCtrl->Label()))+MARGIN_ADJUST_TXTCTRL_DIVIDER);
}
//------------------------------------------------------------------------------
void	click_button(BButton* oTgtButton, bool oForce)
{
	if ( oTgtButton == NULL )
		return;
	if ( !oTgtButton->IsEnabled() && !oForce )
		return;
	oTgtButton->SetValue(B_CONTROL_ON);
	if ( oTgtButton->Window() != NULL ) {
		oTgtButton->Window()->UpdateIfNeeded();
	}
	snooze(TIME_CLICK_BUTTON_INTERVAL);
	oTgtButton->SetValue(B_CONTROL_OFF);
	oTgtButton->Invoke();
}
//------------------------------------------------------------------------------
void	close_window(BWindow** oTgtWin)
{
	if ( *oTgtWin != NULL ) {
		if ( (*oTgtWin)->Lock() ) {
			(*oTgtWin)->Quit();
			*oTgtWin = NULL;
		}
	}
}
//------------------------------------------------------------------------------
status_t	copy_file(const char* oSrcFName, const char* oDest)
{
	char		aAttrName[B_ATTR_NAME_LENGTH];
	char		aDestFName[B_FILE_NAME_LENGTH];
	char*		aAttrData;
	attr_info	aAttrInfo;
	string		aCmdLine;
	BFile		aDestFile;
	BFile		aSrcFile(oSrcFName, B_READ_ONLY);
	BNode		aDestNode(oDest);

	// この関数未デバッグ
	// コピー先ファイル名の決定
	if ( aDestNode.IsDirectory() ) {
		// コピー先はフォルダ
		strcpy(aDestFName, oDest);
		if ( aDestFName[strlen(aDestFName)-1] != '/' ) {
			strcat(aDestFName,"/");
		}
		strcat(aDestFName, extract_file_name(oSrcFName).c_str());
	} else {
		// コピー先はファイル
		strcpy(aDestFName, oDest);
	}
	// 本体コピー
	aCmdLine = string("cp \"")+oSrcFName+"\" \""+aDestFName+"\"";
	system(aCmdLine.c_str());
	if ( aDestFile.SetTo(aDestFName, B_READ_WRITE) != B_OK ) {
		return B_ERROR;
	}
	// 属性コピー
	while ( aSrcFile.GetNextAttrName(aAttrName) == B_OK ) {
		aSrcFile.GetAttrInfo(aAttrName, &aAttrInfo);
		aAttrData = new char [aAttrInfo.size];
		aSrcFile.ReadAttr(aAttrName, aAttrInfo.type, 0, aAttrData, aAttrInfo.size);
		aDestFile.WriteAttr(aAttrName, aAttrInfo.type, 0, aAttrData, aAttrInfo.size);
		delete aAttrData;
	}
	return B_OK;
}
//------------------------------------------------------------------------------
BBitmap*	create_icon8_from_icon24(BBitmap* oIcon24, int32 oTransPos)
{
	uint8*		aBits;
	uint8		aTransColor;	// 透明色
	BBitmap*	aIcon8;
	BBitmap		aIcon8Work(oIcon24->Bounds(), B_CMAP8, true);
	BView*		aIcon8View;

	// 24 -> 8
	aIcon8View = new BView(aIcon8Work.Bounds(), "Icon8WorkView", 0, 0);
	aIcon8Work.AddChild(aIcon8View);
	if ( aIcon8View->Window()->Lock() ) {
		aIcon8View->DrawBitmap(oIcon24, B_ORIGIN);
		aIcon8View->Window()->Unlock();
	}
	// ビュー無しのビットマップにコピー
	aIcon8 = new BBitmap(oIcon24->Bounds(), B_CMAP8);
	aIcon8->SetBits(aIcon8Work.Bits(), aIcon8Work.BitsLength(), 0, B_CMAP8);
	// 透過処理
	aBits = reinterpret_cast<uint8*>(aIcon8->Bits());
	aTransColor = aBits[oTransPos];
	for ( int32 i = 0 ; i < aIcon8->BitsLength() ; i++ ) {
		if ( aBits[i] == aTransColor ) {
			aBits[i] = B_TRANSPARENT_MAGIC_CMAP8;
		}
	}
	return aIcon8;
}
//------------------------------------------------------------------------------
void	delete_mfield_mitems(BMenuField* oMField)
{
	while ( oMField->Menu()->CountItems() > 0 ) {
		delete oMField->Menu()->RemoveItem(static_cast<int32>(0));
	}
}
//------------------------------------------------------------------------------
uint32	detect_char_set(const char* oStr)
{
	int32	i;
	int32	aBytes;
	int32	aESCs = 0;
	int32	aSrcSize;
	int32	aUtf8Errs = 0;
	uint32	aCharset;	// 判定結果

	aSrcSize = strlen(oStr);
	i = 0;
	while ( i < aSrcSize ) {
		if ( (oStr[i] & 0x80) != 0 ) {
			// 多バイト文字
			if ( (oStr[i] & 0xC0) != 0xC0 ) {	// 先頭バイトの上位２ビットは立っていなくてはならない
				aUtf8Errs++;
			}
			aBytes = 1;
			while ( ((oStr[i] << aBytes) & 0x80) != 0 ) {
				if ( (oStr[i+aBytes] & 0xC0) != 0x80 ) {	// トレーリィングバイトは 10xxxxxx でなくてはならない
					aUtf8Errs++;
				}
				aBytes++;
			}
			i += aBytes;
		} else {
			// ASCII
			if ( oStr[i] == 0x1B ) {	// ESC
				aESCs++;
			}
			i++;
		}
	}
	if ( aESCs > 0 ) {
		aCharset = B_JIS_CONVERSION;
	} else if ( aUtf8Errs > 0 ) {
		aCharset = B_SJIS_CONVERSION;
	} else {
		aCharset = B_UNICODE_UTF8;
	}
	return aCharset;
}
//------------------------------------------------------------------------------
int32	detect_cr_type(const char* oStr)
{
	const char*	p = oStr;
	int32		aCRType;
	int32		aNumCR = 0;
	int32		aNumLF = 0;

	while ( (*p) != '\0' ) {
		switch ( *p ) {
		case '\n':	// LF
			aNumLF++;
			break;
		case '\r':	// CR
			aNumCR++;
			break;
		}
		p++;
	}
	if ( aNumCR == aNumLF && aNumCR != 0 ) {
		aCRType = CR_TYPE_CRLF;
	} else if ( aNumCR > aNumLF ) {
		aCRType = CR_TYPE_CR;
	} else {
		aCRType = CR_TYPE_LF;
	}
	return aCRType;
}
//------------------------------------------------------------------------------
/* ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
フォルダなら末尾に '/' をつけ、ファイルなら '/' をつけない
リンクは解決せずにそのまま追加
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
status_t	get_files(const string& oFolderName, list<string>* oFiles, bool oRecursive)
{
	string		aPathName;
	BDirectory	aFolder(oFolderName.c_str());
	BEntry		aEntry;

	if ( aFolder.InitCheck() != B_OK )
		return B_ERROR;
	// フォルダをリストに追加
	aPathName = oFolderName;
	if ( aPathName[aPathName.length()-1] != '/' ) {
		aPathName += '/';
	}
	oFiles->push_back(aPathName);
	// ファイルを検索
	aFolder.Rewind();
	while ( aFolder.GetNextEntry(&aEntry) == B_OK ) {
		aPathName = BPath(&aEntry).Path();
		if ( aEntry.IsDirectory() ) {
			// フォルダ
			if ( oRecursive ) {
				if ( get_files(aPathName.c_str(), oFiles, oRecursive) != B_OK )
					return B_ERROR;
			}
		} else if ( aEntry.IsSymLink() ) {
			// リンク
			if ( BEntry(aPathName.c_str(), true).IsDirectory() ) {
				if ( oRecursive ) {
					oFiles->push_back(aPathName+"/");	// リンクを解決して再帰呼出すると循環リンクでハマるのでやらない
				}
			} else {
				oFiles->push_back(aPathName);
			}
		} else {
			// ファイル
			oFiles->push_back(aPathName);
		}
	}
	return B_OK;
}
//------------------------------------------------------------------------------
status_t	get_icons(BBitmap** oLargeIcon, BBitmap** oMiniIcon)
{
	app_info	aAppInfo;
	status_t	aResult;
	BMimeType	aMime;

	be_app->GetAppInfo(&aAppInfo);
	try {
		if ( aMime.SetTo(aAppInfo.signature) != B_OK )
			throw 0;
		if ( oLargeIcon != NULL ) {	// 大きいアイコンを取得
			*oLargeIcon = new BBitmap(BRect(0, 0, B_LARGE_ICON-1, B_LARGE_ICON-1), B_CMAP8);
			aMime.GetIcon(*oLargeIcon, B_LARGE_ICON);
		}
		if ( oMiniIcon != NULL ) {	// 小さいアイコンを取得
			*oMiniIcon = new BBitmap(BRect(0, 0, B_MINI_ICON-1, B_MINI_ICON-1), B_CMAP8);
			aMime.GetIcon(*oMiniIcon, B_MINI_ICON);
		}
		aResult = B_OK;
	} catch (...) {
		aResult = B_ERROR;
	}
	return aResult;
}
//------------------------------------------------------------------------------
status_t	get_save_ref(const BMessage* oMsg, entry_ref* oRef)
{
	const char*	aNPFNameRef;
	entry_ref	aDirERef;
	BDirectory	aDir;

	oMsg->FindRef(B_MSG_NAME_DIRECTORY, &aDirERef);
	oMsg->FindString(B_MSG_NAME_NAME, &aNPFNameRef);
	aDir.SetTo(&aDirERef);
	return BEntry(&aDir, aNPFNameRef).GetRef(oRef);
}
//------------------------------------------------------------------------------
bool	is_same_rgb_color(const rgb_color& oLHS, const rgb_color& oRHS)
{
	return (oLHS.red == oRHS.red && oLHS.green == oRHS.green && oLHS.blue == oRHS.blue && oLHS.alpha == oRHS.alpha);
}
//------------------------------------------------------------------------------
string	locale_text_with_default(const char* oKey, const char* oDefault)
{
	string	aText;

	aText = _T(oKey);
	if ( aText == oKey ) {
		aText = oDefault;
	}
	return aText;
}
//------------------------------------------------------------------------------
string	merge_accelerator_key(const string& oAccFormat, const string& oAccKey, const string& oLabel)
{
	string	aNewLabel;
	string::size_type	aInsPos;
	string::size_type	aRepPos = oAccFormat.find("a");

	if ( aRepPos != string::npos ) {
		aNewLabel = oAccFormat.substr(1);
		aNewLabel.replace(aRepPos-1, 1, oAccKey);
	}
	if ( oAccFormat[0] == '\1' ) {
		aNewLabel += oLabel;
	} else {
		if ( (aInsPos = oLabel.find("...")) != string::npos || (aInsPos = oLabel.find('[')) != string::npos ||
				(aInsPos = oLabel.find("：")) != string::npos || (aInsPos = oLabel.find(":")) != string::npos ||
				(aInsPos = oLabel.find(">>")) != string::npos || (aInsPos = oLabel.find("<<")) != string::npos ||
				(aInsPos = oLabel.find("→")) != string::npos || (aInsPos = oLabel.find("←")) != string::npos ) {
			while ( aInsPos > 0 && oLabel[aInsPos-1] == ' ' ) {
				aInsPos--;
			}
			aNewLabel = oLabel.substr(0, aInsPos)+aNewLabel+oLabel.substr(aInsPos);
		} else {
			aNewLabel = oLabel+aNewLabel;
		}
	}
	return aNewLabel;
}
//------------------------------------------------------------------------------
/* ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
SendMessage() の BMessage 引数は const ではないので、この関数の引数を const BMessage& にはできない。
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
status_t	send_message_with_lock(BHandler* oTgt, BMessage oMsg)
{
	BLooper*	aLooper;
	BMessenger	aMsger(oTgt);

	while ( !aMsger.LockTarget() ) {
		snooze(FUC_TIME_SNOOZE_MIN);
	}
	aMsger.SendMessage(&oMsg);
	aMsger.Target(&aLooper)->UnlockLooper();
}
//------------------------------------------------------------------------------
status_t	set_file_panel_priority(BFilePanel* oTgt, int32 oNewPriority)
{
	if ( oTgt == NULL )
		return B_ERROR;
	set_thread_priority(oTgt->Window()->Thread(), oNewPriority);
	return B_OK;
}
//------------------------------------------------------------------------------
char	short_cut_from_label(const string& oLabel)
{
	string::size_type	aBeginPos;
	string::size_type	aEndPos;

	// Windows 形式のチェック
	if ( (aBeginPos = oLabel.rfind('(')) != string::npos && (aEndPos = oLabel.rfind(')')) != string::npos ) {
		if ( aEndPos-aBeginPos == 2 )
			return tolower(oLabel[aBeginPos+1]);
	}
	// 先頭にショートカットが表示される形式のチェック
	if ( oLabel.find(')') == 1 || oLabel.find(' ') == 1 || oLabel.find("・") == 1 )
		return tolower(oLabel[0]);
	return 0;
}
//------------------------------------------------------------------------------
#if 0
int32	show_alert(const char* oCaption, const char* oMsg, const char* oButton0Label, const char* oButton1Label,
		const char* oButton2Label, int32 oCancelButton, alert_type oType)
{
	const char*	aButtonLabels[3];
	string		aStr;
	BAlert*		aAlert;

	aButtonLabels[0] = oButton0Label;
	if ( oButton1Label != NULL && oButton1Label[0] == '\0' ) {
		aButtonLabels[1] = NULL;
	} else {
		aButtonLabels[1] = oButton1Label;
	}
	if ( oButton2Label != NULL && oButton2Label[0] == '\0' ) {
		aButtonLabels[2] = NULL;
	} else {
		aButtonLabels[2] = oButton2Label;
	}
	aStr = string(oCaption)+"\n\n"+oMsg;
	aAlert = new BAlert(oCaption, aStr.c_str(), aButtonLabels[0], aButtonLabels[1], aButtonLabels[2], B_WIDTH_AS_USUAL, oType);
	// ショートカットの設定
	for ( int i = 0 ; i < 3 ; i++ ) {
		if ( aButtonLabels[i] != NULL ) {
			if ( oCancelButton == i ) {
				aAlert->SetShortcut(i, B_ESCAPE);
			} else {
				aAlert->SetShortcut(i, short_cut_from_label(aButtonLabels[i]));
			}
		}
	}
	// 表示
//	xAlert->SetFlags(B_ASYNCHRONOUS_CONTROLS);
	return aAlert->Go();
}
//------------------------------------------------------------------------------
int32	show_alert2(const string& oCaption, const string& oMsg, const string& oButton0Label, const string& oButton1Label,
		const string& oButton2Label, int32 oCancelButton, alert_type oType)
{
	return show_alert(oCaption.c_str(), oMsg.c_str(), oButton0Label.c_str(), oButton1Label.c_str(),
			oButton2Label.c_str(), oCancelButton, oType);
}
#endif
//------------------------------------------------------------------------------
int32	show_alert3(const string& oCaption, const string& oMsg, const string& oButton0Label, const string& oButton1Label,
		const string& oButton2Label, int32 oCancelButton, alert_type oType)
{
	const char*	aButtonLabels[3];
	string		aText;
	BAlert*		aAlert;

	// ボタン
	aButtonLabels[0] = oButton0Label.c_str();
	if ( oButton1Label.empty() ) {
		aButtonLabels[1] = NULL;
	} else {
		aButtonLabels[1] = oButton1Label.c_str();
	}
	if ( oButton2Label.empty() ) {
		aButtonLabels[2] = NULL;
	} else {
		aButtonLabels[2] = oButton2Label.c_str();
	}
	// テキスト
	aText = oCaption+"\n\n"+oMsg;
	aAlert = new BAlert(oCaption.c_str(), aText.c_str(), aButtonLabels[0], aButtonLabels[1], aButtonLabels[2], B_WIDTH_AS_USUAL, oType);
	// ショートカットの設定
	for ( int i = 0 ; i < 3 ; i++ ) {
		if ( aButtonLabels[i] != NULL ) {
			if ( oCancelButton == i ) {
				aAlert->SetShortcut(i, B_ESCAPE);
			} else {
				aAlert->SetShortcut(i, short_cut_from_label(aButtonLabels[i]));
			}
		}
	}
	// 表示
	return aAlert->Go();
}
//------------------------------------------------------------------------------
status_t	show_core(const char* oMIME, const char* oAddr)
{
	char*		aArgV;
	status_t	aResult;

	aArgV = new char [strlen(oAddr)+1];
	strcpy(aArgV, oAddr);
	aResult = be_roster->Launch(oMIME, 1, &aArgV);
	delete [] aArgV;
	return aResult == B_OK || aResult == B_ALREADY_RUNNING ? B_OK : aResult;
}
//------------------------------------------------------------------------------
status_t	show_help(const char* oFileName)
{
	char		aMIME[B_MIME_TYPE_LENGTH];
	BFile		aFile(oFileName, B_READ_ONLY);
	BNodeInfo	aNodeInfo;

	if ( aNodeInfo.SetTo(&aFile) != B_OK )
		return B_ERROR;
	aNodeInfo.GetType(aMIME);
	return show_core(aMIME, oFileName);
}
//------------------------------------------------------------------------------
status_t	show_url(const char* oURL)
{
	return show_core(FUC_MIME_TYPE_HTML, oURL);
}
//------------------------------------------------------------------------------
//==============================================================================
#ifdef	DEBUG
extern "C" _EXPORT	const char	gDebugMarkLibSHINTA2[] = "DEBUG/debug";
#endif
//==============================================================================
