#ifndef	___MiscUtils_H_
#define	___MiscUtils_H_
//------------------------------------------------------------------------------
// BeOS
#include <Alert.h>
#include <Bitmap.h>
#include <Button.h>
#include <CheckBox.h>
#include <FilePanel.h>
#include <MenuField.h>
#include <RadioButton.h>
#include <interface/StringView.h>
#include <TextControl.h>
// C++
#include <list>
#include <string>
//------------------------------------------------------------------------------
const char	MUT_MSG_NAME_NEXT_MSG[] = "NextMsg";
const char	MUT_MSG_NAME_NEXT_MSG_TGT[] = "NextMsgTgt";
//------------------------------------------------------------------------------
enum	{ CR_TYPE_LF /* '\n' BeOS */, CR_TYPE_CRLF /* '\r\n' Win */, CR_TYPE_CR /* '\r' Mac */ };	// 改行コード
//==============================================================================
status_t	add_next_msg(BMessage* oSendMsg, const BMessage& oNextMsg, const BHandler* oNextMsgTgt);	// NextMsg を入れる
void		adjust_button_width(BButton* oButton);					// Button の幅を最適化
void		adjust_cbox_width(BCheckBox* oCBox);					// CBox の幅を最適化
void		adjust_mfield_divider(BMenuField* oMField);				// MField の Divider を最適化
void		adjust_rbutton_width(BRadioButton* oRButton);			// RButton の幅を最適化
void		adjust_str_view_width(BStringView* oStrView);			// StrView の幅を最適化
void		adjust_txt_ctrl_divider(BTextControl* oTxtCtrl);		// TxtCtrl の Divider を最適化
template <class T> void	adjust_value(T* oVal, T oMin, T oMax);		// 数値を範囲内に収める
void		click_button(BButton* oTgtButton, bool oForce = false);	// ボタンクリックをシミュレート
void		close_window(BWindow** oTgtWin);						// ウィンドウを強制的に閉じる
status_t	copy_file(const char* oSrcFName, const char* oDest);	// ファイルを属性を含めてコピー
BBitmap*	create_icon8_from_icon24(BBitmap* oIcon24, int32 oTransPos);	// 24bit アイコンから 8bit アイコンを得る
void		delete_mfield_mitems(BMenuField* oMField);				// メニューアイテムを削除
uint32		detect_char_set(const char* oStr);						// 文字コードの判定
int32		detect_cr_type(const char* oStr);						// 改行コードの判定
status_t	get_files(const string& oFolderName, list<string>* oFiles, bool oRecursive);	// フォルダ内のファイル一覧
status_t	get_icons(BBitmap** oLargeIcon, BBitmap** oMiniIcon);	// アイコンをアロケートして得る
status_t	get_save_ref(const BMessage* oMsg, entry_ref* oRef);	// セーブパネルのメッセージから、保存ファイルを得る
bool		is_same_rgb_color(const rgb_color& oLHS, const rgb_color& oRHS);	// rgb_color を比較 | 同じなら true, 違うなら false
string		locale_text_with_default(const char* oKey, const char* oDefault);	// キーがロケール辞書に無い場合はデフォルト値を使用
string		merge_accelerator_key(const string& oAccFormat, const string& oAccKey, const string& oLabel);	// アクセラレータキーを付加
status_t	send_message_with_lock(BHandler* oTgt, BMessage oMsg);	// 送り先をロックしてからメッセージを送付（スレッドからウィンドウにメッセージを送る際に使用する）
status_t	set_file_panel_priority(BFilePanel* oTgt, int32 oNewPriority);	// ファイルパネルのプライオリティーを設定
template <class T> void	set_str_view_num(BStringView* oTgtStrView, T oVal);	// ストリングビューに数値を設定
template <class T> void	set_txt_ctrl_num(BTextControl* oTgtTxtCtrl, T oVal);	// テキストコントロールに数値を設定
char		short_cut_from_label(const string& oLabel);				// ショートカットキーを抽出（小文字で返す）
//int32		show_alert(const char* oCaption, const char* oMsg, const char* oButton0Label, const char* oButton1Label = NULL,
//			const char* oButton2Label = NULL, int32 oCancelButton = -1, alert_type oType = B_INFO_ALERT);	// アラートパネルの表示
//int32		show_alert2(const string& oCaption, const string& oMsg, const string& oButton0Label, const string& oButton1Label = "",
//			const string& oButton2Label = "", int32 oCancelButton = -1, alert_type oType = B_INFO_ALERT);	// アラートパネルの表示
int32		show_alert3(const string& oCaption, const string& oMsg, const string& oButton0Label, const string& oButton1Label = string(),
			const string& oButton2Label = string(), int32 oCancelButton = -1, alert_type oType = B_INFO_ALERT);	// アラートパネルの表示
status_t	show_help(const char* oFileName);						// ヘルプの表示
status_t	show_url(const char* oURL);								// ウェブページの表示
//==============================================================================
template <class T>
void	adjust_value(T* oVal, T oMin, T oMax)
{
	if ( *oVal < oMin ) {
		*oVal = oMin;
	}
	if ( *oVal > oMax ) {
		*oVal = oMax;
	}
}
//------------------------------------------------------------------------------
template <class T>
void	set_str_view_num(BStringView* oTgtStrView, T oVal)
{
	BString	aStream;

	aStream << oVal;
	oTgtStrView->SetText(aStream.String());
}
//------------------------------------------------------------------------------
template <class T>
void	set_txt_ctrl_num(BTextControl* oTgtTxtCtrl, T oVal)
{
	BString	aStream;

	aStream << oVal;
	oTgtTxtCtrl->SetText(aStream.String());
}
//------------------------------------------------------------------------------
//==============================================================================
#endif	// ___MiscUtils_H_
