#ifndef	___MouseDownManager_H_
#define	___MouseDownManager_H_
//------------------------------------------------------------------------------
// BeOS
#include <View.h>
//==============================================================================
class	TMouseDownManager
{
public:
	TMouseDownManager(BView* oTgtView);
	virtual	~TMouseDownManager();

protected:
	void			ManageMouseDown(BPoint oPoint);
	void			ManageMouseMoved(BPoint oPoint, uint32 oTransit, const BMessage* oMsg);
	void			ManageMouseUp(BPoint oPoint);
	virtual void	MouseClickLeftDouble(BPoint oPoint);	// 左ボタン 2 回クリック
	virtual void	MouseClickLeftSingle(BPoint oPoint);	// 左ボタン 1 回クリック
	virtual void	MouseClickRightDouble(BPoint oPoint);	// 右ボタン 2 回クリック
	virtual void	MouseClickRightSingle(BPoint oPoint);	// 右ボタン 1 回クリック
	virtual void	MouseDownLeft(BPoint oPoint);			// 左ボタン押下
	virtual void	MouseDownRight(BPoint oPoint);			// 右ボタン押下
	virtual void	MouseDragBeginLeft(BPoint oBeginPoint, BPoint oPoint);		// 左ボタンドラッグ開始
	virtual void	MouseDragBeginRight(BPoint oBeginPoint, BPoint oPoint);		// 右ボタンドラッグ開始
	virtual void	MouseDragEndLeft(BPoint oBeginPoint, BPoint oPoint);		// 左ボタンドラッグ終了
	virtual void	MouseDragEndRight(BPoint oBeginPoint, BPoint oPoint);		// 右ボタンドラッグ終了
	virtual void	MouseDraggingLeft(BPoint oBeginPoint, BPoint oPoint);		// 左ボタンドラッグ中
	virtual void	MouseDraggingRight(BPoint oBeginPoint, BPoint oPoint);		// 右ボタンドラッグ中
	virtual void	MouseUpLeft(BPoint oPoint);				// 左ボタン押下の終了
	virtual void	MouseUpRight(BPoint oPoint);			// 右ボタン押下の終了

private:
	bool	mLastDrag;										// ドラッグかクリックか
	int32	mLastButtons;									// 押されたボタン
	int32	mLastClicks;									// マウスクリックの回数
	BPoint	mLastPoint;										// マウスダウン位置
	BView*	mTgtView;
};
//==============================================================================
#endif	// ___MouseDownManager_H_
