/*==============================================================================
		ノードモニターのメッセージを受け取るコンポーネント for Zeta		Ver 1.11
		Copyright (C) 2002-2004 by ＳＨＩＮＴＡ
==============================================================================*/

/*==============================================================================
 Ver. |					主な改良点
--------------------------------------------------------------------------------
 ---- | 2004/05/02 (Sun) 開発着手。
 1.00 | 2004/05/02 (Sun) add 時代のクラスを元に構築。
 1.10 | 2004/05/02 (Sun) リスナーを指定できるようにした。
==============================================================================*/

/*=== Memo =====================================================================
stop_watching() は BHandler 一括でストップしてしまうので、直接 BView で受けてしまうと不便。
そこで、BHandler 継承の TNodeMonitorHandler で受ける。
==============================================================================*/

//------------------------------------------------------------------------------
#include "NodeMonitorHandler.h"
//------------------------------------------------------------------------------
// BeOS
#include <Looper.h>
#include <NodeMonitor.h>
// Add2
#include <add2/BeConstants.h>
//==============================================================================
TNodeMonitorHandler::TNodeMonitorHandler(uint32 oSendMsg)
		: SUPER(),
		mSendCmd(oSendMsg)
{
	mListenerSpecified = false;
}
//------------------------------------------------------------------------------
TNodeMonitorHandler::TNodeMonitorHandler(uint32 oSendMsg, const BMessenger& oListenerMsger)
		: SUPER(),
		mSendCmd(oSendMsg), mListenerMsger(oListenerMsger)
{
	mListenerSpecified = true;
}
//------------------------------------------------------------------------------
TNodeMonitorHandler::~TNodeMonitorHandler()
{
}
//------------------------------------------------------------------------------
void	TNodeMonitorHandler::MessageReceived(BMessage* oMsg)
{
	int32		aOpCode;

	if ( oMsg->what == B_NODE_MONITOR ) {
		oMsg->FindInt32(B_MSG_NAME_OPCODE, &aOpCode);
		if ( aOpCode != B_ATTR_CHANGED ) {
			oMsg->what = mSendCmd;
			if ( mListenerSpecified ) {
				mListenerMsger.SendMessage(oMsg);
			} else {
				BMessenger(static_cast<BLooper*>(Looper())).SendMessage(oMsg);
			}
		}
	} else {
		SUPER::MessageReceived(oMsg);
	}
}
//==============================================================================
