#ifndef	___Splitter_H_
#define	___Splitter_H_
//------------------------------------------------------------------------------
// BeOS
#include <ScrollBar.h>
#include <View.h>
// C++
#include <list>
//------------------------------------------------------------------------------
using namespace	std;
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//==============================================================================
class	TSplitter : public BView
{
public:
	TSplitter(BRect oFrame, const char* oName, uint32 oResizingMode, orientation oPosture);
	virtual	~TSplitter();

	// スプリッタに動かされるビュー（配下）を登録（ oFloower の親はスプリッタの親と同じでなければならない）
	status_t	RegisterFollowerLeftTop(BView* oFollower);
	status_t	RegieterFollowerRightBottom(BView* oFollower);

	// 配下の最小サイズ
	void		SetMinSizes(float oLeftTop, float oRightBottom);

	// MoveTo の代替
	void		SetPosition(float oPos);

private:
	typedef	BView	SUPER;

	void			AdjustAllFollowers();
	void			AdjustFollowerLeftTop(BView* oFollower);
	void			AdjustFollowerRightBottom(BView* oFollower);
	virtual	void	AttachedToWindow();
	virtual void	Draw(BRect oUpdateRect);
	virtual	void	MouseDown(BPoint oWhere);
	void			MouseMoved(BPoint oWhere, uint32 oCode, const BMessage* oMsg);
	virtual	void	MouseUp(BPoint oWhere);

	bool			mDragging;
	float			mMinSizeLT;
	float			mMinSizeRB;
	list<BView*>	mFollowerLT;
	list<BView*>	mFollowerRB;
	orientation		mPosture;
	BPoint			mMouseDownPointOffset;
};
//==============================================================================
#endif	// ___Splitter_H_
